package screenblocker;

import java.util.*;

public class DataBank {
	public String t = "";
	public String r = "";
	public DataBank(String title) {
		t=title;
	}
	public DataBank() {
		t="";
		r="";
	}
	public void create() {
		KFile.writeFile(t,r);
	}
	public void refresh() {
		KFile.writeFile(t,r);
	}
	public void load() {
		r=KFile.readFile(t);
	}
	public void load(String s) {
		t=s;
		r=KFile.readFile(t);
	}
	public String getValue(String name) {
		try {
		StringTokenizer st = new StringTokenizer(r, "\n");
		String next = "";
		String done = "";
		while(st.hasMoreTokens()) {
			next = st.nextToken();
			if(next.equals("!data!")) {
				while(!next.equals("!/data!")) {
					next=st.nextToken();
				}
			}
			if(!next.startsWith("$")&&next.equals(name)) {
				String nn = st.nextToken();
				done = nn.substring(1, nn.length());
				break;
			}
		}
		return done;
		} catch(Exception E) {
			return "ERROR";
		}
	}
	public void removeValue(String name) {
		String value_of = getValue(name);
		StringTokenizer st = new StringTokenizer(r, "\n");
		String exit = "";
		while(st.hasMoreTokens()) {
			String next = st.nextToken();
			if(!next.equals(name) && !next.equals("$"+value_of)) {
				exit+=next+"\n";
			}
		}
		r=exit;		
	}
	public void setValue(String name, String value) {
		removeValue(name);
		r="\n"+name+"\n$"+value+"\n"+r;
		KFile.writeFile(t,r);
	}
	public void setData(DataBank data, String name) {
		String x = data.r;
		r="\n!data!\n"+name+"\n"+x+"\n!/data!"+r;
		KFile.writeFile(t,r);
	}
	public DataBank getData(String name) {
		DataBank db = new DataBank();
		StringTokenizer st = new StringTokenizer(r, "\n");
		String next = "";
		String done = "";
		while(st.hasMoreTokens()) {
			next = st.nextToken();
			if(next.equals("!data!")) {
				if(st.nextToken().equals(name)) {
					while(!next.equals("!/data!")) {
						next=st.nextToken();
						done+=next+"\n";
					}
				}
				else {
					while(!next.equals("!/data!")) {
						next=st.nextToken();
					}
				}
			}
		}
		db.r=done;
		return db;
	}
}
